
#include <math.h>
#include <string.h>

#define XS 320
#define YS 200
#define BRD 34 /* Border width */
#define GAP 9  /* Gap between "frames" */

#define HX 22  /* The dimensions of the film holes */
#define HY 12
#define HGAP 8

void filmi(unsigned char *d,unsigned char *s,float pos)
{
    int sy,y,n,i,wid;

    sy=(int)(pos*YS)%YS;

    for(y=0;y<YS;y++)
    {
        /* Copy the source buffer */
        if((y+sy)%YS<GAP || (y+sy)%YS>YS-GAP)
            memset(&d[BRD+y*XS],0,XS-BRD*2);
        else
            memcpy(&d[BRD+y*XS],&s[BRD+(y+sy)%YS*XS],XS-BRD*2);
        
        memset(&d[y*XS],0,BRD); /* The black edges */
        memset(&d[XS-BRD+y*XS],0,BRD);

        if((y+sy%YS)/(HY+HGAP)&1) /* The holes */
        {
            /* Round off edges */
            if((y+sy%YS)%(HY+HGAP)==0 || (y+sy%YS)%(HY+HGAP)==(HY+HGAP-1))
                wid=1;
            else
                wid=0;
            
            memset(&d[wid+y*XS+BRD/2-HX/2],0xff,HX-wid*2);
            memset(&d[wid+y*XS+XS-BRD+(BRD/2-HX/2)],0xff,HX-wid*2);
        }
    }
}
