#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#include "video.h"

/* original dimensions */
#define OW 320
#define OH 240

#define COLORS 255

unsigned char * make_bitti_muunnos();
int filesize(char * filename);

//float frame=0;
float video_spd=1.0;
float video_dir=1.0;

void video_turn_direction() {
    video_dir*=-1.0;
}

void video_zero_frame(VIDEO * vid) {
    vid->frame=0;
}
void set_video_spd(float spd) {
    video_spd=spd;
}

void show_video(unsigned char * dest, VIDEO * vid, int tick, int tyhjaa) {
    static unsigned char * bitti_muunnos=NULL;
    int x,y,xx,i;
    int src;

    static unsigned char lookup1[256];
    static unsigned char lookup2[256];

    unsigned char * dstc;
    unsigned char a;

    float ff;
    static int ot;
    int dt;
    float fr;
    int fri1,fri2;
    int src1,src2;
    if (!bitti_muunnos) {
        bitti_muunnos=make_bitti_muunnos();
    }

    dt=tick-ot;
    ot=tick;

    vid->frame+=(0.025*(float)dt)*video_spd*video_dir;
    if (vid->frame<0)
	vid->frame+=vid->N*1000.0;

//    printf("frame=%f\n",frame);

    fr=fmod(floor(vid->frame),vid->N)*2.0;
    if (fr>=vid->N)
	fr=vid->N*2.0-fr-1;
    fri1=(int)fr*8000;

    fr=fmod(ceil(vid->frame),vid->N)*2.0;
    if (fr>=vid->N)
	fr=vid->N*2.0-fr-1;
    fri2=(int)fr*8000;

    ff=vid->frame-floor(vid->frame);

    dstc=dest;
    src=0;

    for (i=0; i<256; i++) {
	lookup1[i]=(1.0-ff)*i;
	lookup2[i]=(ff)*i;
    }


    if (tyhjaa) {
	for (y=0; y<VH; y++)
	    for (x=0; x<(VW/8); x++) {
		src1=vid->buf[fri1+src]*8;
		src2=vid->buf[fri2+src]*8;

		for (xx=0; xx<8; xx++) {
		    i=
			lookup1[bitti_muunnos[src1++]]+
			lookup2[bitti_muunnos[src2++]];

		    *dstc=i;
		    dstc++;


		}
		src++;
	    }



    } else {
	for (y=0; y<VH; y++)
	    for (x=0; x<(VW/8); x++) {
		src1=vid->buf[fri1+src]*8;
		src2=vid->buf[fri2+src]*8;

		for (xx=0; xx<8; xx++) {
		    i=
			lookup1[bitti_muunnos[src1++]]+
			lookup2[bitti_muunnos[src2++]]
			+*dstc;

		    if (i>255)
			i=255;

		    if (i!=0)
			*dstc=i;
                    dstc++;

		}
		src++;
	    }
    }

}


void load_raw_video(VIDEO * vid, char * name) {
    FILE * f;
    int size;
    size=filesize(name);
    vid->buf=(char *)malloc(size);
    f=fopen(name,"rb");
    fread(vid->buf,size,1,f);
    vid->N=size/(VW/8*VH);
    fclose(f);
}

unsigned char * make_bitti_muunnos() {
    unsigned char * bitti_muunnos;
    int y;

    bitti_muunnos=(char *)malloc(256*8);
    memset(bitti_muunnos,0,256*8);
    for (y=0; y<256; y++) {
	if ((y & 1)!=0)
	    bitti_muunnos[y*8+0]=COLORS-1;
	if ((y & 2)!=0)
	    bitti_muunnos[y*8+1]=COLORS-1;
	if ((y & 4)!=0)
	    bitti_muunnos[y*8+2]=COLORS-1;
	if ((y & 8)!=0)
	    bitti_muunnos[y*8+3]=COLORS-1;
	if ((y & 16)!=0)
	    bitti_muunnos[y*8+4]=COLORS-1;
	if ((y & 32)!=0)
	    bitti_muunnos[y*8+5]=COLORS-1;
	if ((y & 64)!=0)
	    bitti_muunnos[y*8+6]=COLORS-1;
	if ((y & 128)!=0)
	    bitti_muunnos[y*8+7]=COLORS-1;

    }

    return bitti_muunnos;
}

int filesize(char * filename) {
    FILE * f;
    int size;
    f=fopen(filename,"rb");
    if (f==NULL) {
	printf("    error opening %s!\n",filename);
	return -1;
    }
    fseek(f,0,SEEK_END);
    size=ftell(f);
    fclose(f);
    return (size);
}
